.386
.model flat,stdcall
option casemap:none


Viewer 			proto :DWORD,:DWORD,:DWORD,:DWORD

PrepareParse 		proto :DWORD
CenterWnd 		proto :DWORD,:DWORD
LoadBmp 		proto 

AlphaChannal		proto
GrayScale 		proto
FlipHoriz 		proto 
FlipVerti		proto
Invert			proto 

InitiPo			proto
PoParser		proto	
BlurFilter		proto
Blur			proto

SaveBmp 		proto


include bmp.inc






.code
start:
	invoke GetProcessHeap
	mov hHeap,eax
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	mov CommandLine,eax



	invoke Viewer, hInstance,NULL,CommandLine, SW_SHOWDEFAULT	
	invoke ExitProcess,eax


Viewer proc hInst,hPrevInst,CmdLine,CmdShow
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG

	mov   wc.cbSize,sizeof WNDCLASSEX
	mov   wc.lpfnWndProc, offset WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW + 1
	mov   wc.lpszMenuName,1
	mov   wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx,0,addr ClassName,addr AppName,WS_CAPTION or WS_SYSMENU,CW_USEDEFAULT,CW_USEDEFAULT,479,359,NULL,NULL,hInst,NULL
    
	mov   hwnd,eax
	invoke ShowWindow,eax,SW_SHOWNORMAL
	invoke UpdateWindow,hwnd
	invoke GetMenu,hwnd
	mov hMenu,eax

	.while TRUE
		invoke GetMessage, addr msg,NULL,0,0
                .break .IF (!eax)
                invoke TranslateMessage, addr msg
                invoke DispatchMessage, addr msg
	.endw
	mov     eax,msg.wParam
	ret
Viewer endp

LoadBmp proc 

	invoke CreateFile,addr strTemFile,GENERIC_WRITE,FILE_SHARE_WRITE or FILE_SHARE_DELETE or FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hFiled,eax
	invoke WriteFile,hFiled,addr bf,sizeof bf,addr rdbytes,0
	invoke WriteFile,hFiled,addr bi,sizeof bi,addr rdbytes,0
	invoke WriteFile,hFiled,pHeap2,bmpsize,addr rdbytes,0
	invoke CloseHandle,hFiled

	invoke LoadImage,0,addr strTemFile,IMAGE_BITMAP,0,0,LR_LOADFROMFILE	
	.if eax
		mov hbmp,eax
		invoke  InvalidateRect,hwnd,NULL,FALSE
        	invoke  UpdateWindow,hwnd

		;invoke EnableMenuItem,hMenu,2,MF_ENABLED
		invoke EnableMenuItem,hMenu,3,MF_ENABLED
		invoke EnableMenuItem,hMenu,4,MF_ENABLED
		invoke EnableMenuItem,hMenu,5,MF_ENABLED
		invoke EnableMenuItem,hMenu,6,MF_ENABLED
		invoke EnableMenuItem,hMenu,7,MF_ENABLED
		invoke EnableMenuItem,hMenu,8,MF_ENABLED
	.endif
	ret
LoadBmp endp


WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	Local ps :PAINTSTRUCT
	Local hmemdc :DWORD	
	Local hbmpPrev:DWORD

	

	
	.if uMsg == WM_CREATE

		mov ps.fErase,1
	
		mov ofn.lStructSize,SIZEOF ofn
		push hWnd
		pop  ofn.hWndOwner
		push hInstance
		pop  ofn.hInstance
		mov  ofn.lpstrFilter, offset strFilter
		mov  ofn.lpstrFile, offset buffer
		mov  ofn.nMaxFile,260
		mov  ofn.Flags, OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_LONGNAMES or OFN_EXPLORER or OFN_HIDEREADONLY
                mov  ofn.lpstrTitle, offset OpenTitle
		
		
	.elseif uMsg == WM_ERASEBKGND
		.if hbmp
			
			mov eax,1
			jmp @f
	
		.endif
		xor eax,eax
		jmp def
	.elseif uMsg==WM_PAINT
		 invoke  BeginPaint,hWnd,addr ps
		 
       		 .if hbmp
           		invoke  CreateCompatibleDC,eax
          		mov     hmemdc,eax
           		invoke  SelectObject,eax,hbmp
            		mov     hbmpPrev,eax
           		mov     ecx,ps.rcPaint.right
           		mov     edx,ps.rcPaint.bottom
            		mov     eax,bi.biWidth
            		.if eax<ecx
                		xchg    eax,ecx
            		.endif
           		 mov     eax,bi.biHeight
            		.if eax<edx
               			 xchg    eax,edx
            		.endif
           		 sub     ecx,ps.rcPaint.left
            		 sub     edx,ps.rcPaint.top
            		invoke  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ecx,edx,hmemdc,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
                   	
            		invoke  SelectObject,hmemdc,hbmpPrev
           	 	invoke  DeleteDC,hmemdc
			
        	
        	.endif
		invoke  EndPaint,hWnd,addr ps

	.elseif uMsg==WM_COMMAND
		mov eax,wParam
		.if ax == 1
			.if hbmp
				invoke DeleteObject,hbmp	
			.endif
			invoke GetOpenFileName,addr ofn
			.if eax==TRUE
				invoke PrepareParse,ofn.lpstrFile
				;invoke LoadBmp
				invoke AlphaChannal
			.endif

		.elseif ax == 2			
        		
		.elseif ax == 3
			mov esi,pHeap
			mov edi,pHeap2
			mov ecx,bmpsize
			.while ecx > 0
				mov eax,[esi]
				mov [edi],eax
				add esi,4
				add edi,4
				sub ecx,4
			.endw
			invoke LoadBmp
		.elseif ax == 4
			invoke GrayScale
		.elseif ax == 5
			invoke FlipHoriz
		.elseif ax == 6
			invoke FlipVerti		
		.elseif ax == 7
			invoke Invert
		.elseif ax == 8
			invoke Blur
		.endif
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_CLOSE
		.if hbmp
			invoke SaveBmp
		.endif
		invoke DeleteObject,hbmp
		invoke HeapFree,hHeap,0,pHeap
		invoke HeapFree,hHeap,0,pHeap2
		invoke HeapFree,hHeap,0,pHeap3
		invoke DeleteFile,addr strTemFile
		invoke DestroyWindow,hWnd
	.else
def:
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
@@:
	ret
WndProc endp



CenterWnd proc wDim,sDim
	shr sDim,1
	shr wDim,1
	mov eax,wDim
	sub sDim,eax
	mov eax,sDim
	ret
CenterWnd endp



InitiPo proc
	mov esi,pPO
	assume esi:ptr pixel_offset
	xor ecx,ecx
	.while ecx < bi.biHeight
		xor ebx,ebx
		.while ebx < bi.biWidth
			mov [esi].xorigin,bx
			mov [esi].x,bx
			mov [esi].yorigin,cx
			mov [esi].y,cx
			add esi,8
			inc ebx
		.endw
		inc ecx
	.endw
	assume esi:nothing
	ret
InitiPo endp

PoParser proc
	mov esi,pHeap2
	mov edi,pHeap3
	mov ecx,bmpsize
	.while ecx > 0
		mov eax,[esi]
		mov [edi],eax
		add esi,4
		add edi,4
		sub ecx,4
	.endw
	mov esi,pHeap3
	mov edi,pHeap2
	
	mov eax,bi.biWidth
	mul bi.biHeight
	mov ecx,eax
	
	mov ebx,pPO
	assume ebx:ptr pixel_offset
	.while ecx > 0
		
	
		movzx eax,[ebx].xorigin	
		mul lPixel
		mov edx,eax
		push edx
		movzx eax,[ebx].yorigin
		mul spw
		pop edx
		add edx,eax

		xor ax,ax
		mov al,[esi+edx]
		push ax
		mov al,[esi+edx+1]
		push ax
		mov al,[esi+edx+2]
		push ax
		
		movzx eax,[ebx].x
		mul lPixel
		mov edx,eax
		push edx
		movzx eax,[ebx].y
		mul spw
		pop edx
		add edx,eax
		
		pop ax
		mov [edi+edx+2],al
		pop ax
		mov [edi+edx+1],al
		pop ax
		mov [edi+edx],al
		
		add ebx,8
		dec ecx
	.endw
	assume ebx:nothing
	
	ret
PoParser endp

BlurFilter proc
	bt bi.biHeight,0
	.if CARRY?
		mov eax,bmpsize
		add eax,spw
		add eax,3
		invoke HeapReAlloc,hHeap,HEAP_ZERO_MEMORY,pHeap2,eax
		mov pHeap2,eax
	.endif
	mov eax,bi.biWidth
	mul bi.biHeight
	mov ecx,eax
	mov esi,pPO
	assume esi:ptr pixel_offset
	.while ecx > 0
		mov ax,[esi].xorigin
		bt ax,0
		.if CARRY?
			dec ax
			mov [esi].x,ax
		.elseif
			inc ax
			mov [esi].x,ax
		.endif

		mov ax,[esi].yorigin
		bt ax,0
		.if carry?
			dec ax
			mov [esi].y,ax
		.else

			inc ax
			mov [esi].y,ax
		.endif
	@@:
		add esi,8
		dec ecx
	.endw
	assume esi:nothing
	ret
BlurFilter endp

AlphaChannal proc
	mov esi,pHeap2
	mov ecx,bi.biHeight
	.while ecx > 0
		push ecx
		mov ecx,bmpWidth
		push esi
		.while ecx > 0

				mov al,[esi]
				mul transparency
				div hundred
				mov bh,al
				mov bl,100
				sub bl,transparency 
				mov al,0ffh
				mul bl
				div hundred
				add bh,al
				mov [esi],bh
				dec ecx
				inc esi

		.endw
		pop esi
		add esi,spw
		pop ecx
		dec ecx
	.endw
	invoke LoadBmp
	ret
AlphaChannal endp

Blur proc
	invoke BlurFilter
	invoke PoParser
	invoke LoadBmp
	ret
Blur endp

end start
